#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "general.h"
#include "matrix_util.h"
#include "fileio_util.h"
#include "mtf.h"

vector gen_distance_table(int center, double scale, double mink)
{
    int i;
    vector Ret;

    if ( (Ret = vectinit(center)) == NULL ) {
        fprintf(stderr, "Could not allocate memory for gen_distance_table()\n");
        exit (EXIT_FAILURE);
    }
    for (i=1; i<=center; i++) {
        *(Ret+offs(center,1,i,1)) = pow(((double) i)/scale, mink);
    }
    return Ret;
}

double calc_distance(int i, int j, int rows_center, int cols_center, vector distr, vector distc, double mink)
{
    int x, y;
    double powy;

    y = abs(i - rows_center);
    powy = *(distr+offs(rows_center,1,y,1));
    x = abs(j - cols_center);
    return pow(powy + *(distc+offs(cols_center,1,x,1)), 1.0/mink);
}
