#include <stdio.h>
#include <stdlib.h>
#include <string.h>

void usage(void) 
{
    fprintf(stderr, "Usage: diff-eq [-delta <double>] [-inp1 <double>] [-inp2 <double>] -w11 <double> -w12 <double> -w21 <double> -w22 <double> [-xmin <double>] [-xmax <doulble>] [-ymin <double>] [-ymax <double>]\n");
    fprintf(stderr, "\n\tdelta means difference for each vector\n");
    fprintf(stderr, "\tw11,w12,w21,w22 means weights\n");
    fprintf(stderr, "\tinp1, inp2 means input line for each unit\n");
    exit (EXIT_FAILURE);
}

int main ( int argc, char **argv)
{
    int i;
    double delta = 0.5;
    double ddd = 20.0;
    double inp1 = 0.0;
    double inp2 = 0.0;

    double w11=1.0;
    double w12=0.0;
    double w21=0.0;
    double w22=1.0;

    double xmin=-1.0, xmax=1.0, ymin=-1.0, ymax=1.0;
    double dx, dy, x, y, u, v, xx, yy;

    if ( argc <= 1 ) {
	usage();
    }

    for (i = 0; i < argc; i++) {
	if ( strcmp(argv[i], "-help") == 0 ) {
	    usage();
	}
	if ( strcmp(argv[i], "-delta") == 0 ) {
	    delta = atof(argv[++i]);
	    if ( delta == 0.0 ) {
		fprintf(stderr, "Invalid delta=%f\n", delta);
		exit (EXIT_FAILURE);
	    }
	}
	if ( strcmp(argv[i], "-inp1") == 0) {
	    inp1 = atof(argv[++i]);
	}
	if ( strcmp(argv[i], "-inp2") == 0) {
	    inp2 = atof(argv[++i]);
	}
	if ( strcmp(argv[i], "-w11") == 0) {
	    w11 = atof(argv[++i]);
	}
	if ( strcmp(argv[i], "-w12") == 0) {
	    w12 = atof(argv[++i]);
	}
	if ( strcmp(argv[i], "-w21") == 0) {
	    w21 = atof(argv[++i]);
	}
	if ( strcmp(argv[i], "-w22") == 0) {
	    w22 = atof(argv[++i]);
	}
    }

    dx = (xmax-xmin)/ddd;
    dy = (ymax-ymin)/ddd;
    
    printf("### delta=%f\n", delta);
    printf("### w11=%f, w12=%f\n", w11, w12);
    printf("### w21=%f, w22=%f\n", w21, w22);
    printf("### inp1=%f, inp2=%f\n", inp1, inp2);
    printf("### xmin=%f, xmax=%f\n", xmin, xmax);
    printf("### ymin=%f, ymax=%f\n", ymin, ymax);

    for( x = xmin ;  x <= xmax;  x += dx ) {
	for( y = ymin ;  y <= ymax;  y += dy ) {
	    u = w11 * x + w12 * y + inp1;
	    v = w21 * x + w22 * y + inp2;
/*
	    xx = delta * (u - x);
	    yy = delta * (v - y);
	    xx = u * dx;
	    yy = v * dy;
*/
/*
	    xx = delta * u * dx;
	    yy = delta * v * dy;
*/
	    
	    xx = delta * u;
	    yy = delta * v;
	    printf("%f %f %f %f\n", x, y, xx, yy);
	}
    }
    return (EXIT_SUCCESS);
}
