#!/bin/sh

output_and_show ()
{
cat <<EOF> ${DATA}.gpt
set size square
set terminal postscript plus
set label "$params" at 0,1.1
set output "${DATA}.eps"
plot "${DATA}.data" notitle with vector
EOF

gnuplot ${DATA}.gpt
mv ${DATA}.eps ${DATA}.eps.save
sed -e 's/^%%BoundingBox: 50 50 554 770/%%BoundingBox: 0 50 554 600/g' ${DATA}.eps.save > ${DATA}.eps
rm ${DATA}.eps.save
cp -p ${DATA}.eps ${DATA}.eps.$$
gv -scale -2 ${DATA}.eps
}

DATA=phase_sample
#./phase_graph -w11 0 -w12 1 -w21 -1 -w22 0 -delta 3 > ${DATA}.data
./diff-eq -w11 0 -w12 1 -w21 -0.25 -w22 -1 -delta 0.2 > ${DATA}.data
output_and_show
