/*
 *  @(#)ffttest.c - Fast Fourier Transformation 1.0
 */
#include <stdlib.h>
#include <math.h>
#include "matrix_util.h"
#include "fileio_util.h"
#include "fft.h"

#define N 64

int main(void)
{
    int i;
    matrix Re1, Im1, Re2, Im2, Re3, Im3;
    
    Re1 = matinit(N,1);  Im1 = matinit(N,1);
    Re2 = matinit(N,1);  Im2 = matinit(N,1);
    Re3 = matinit(N,1);  Im3 = matinit(N,1);
    
    for (i=1; i<=N; i++) {
        *(Re1+offs(N,1,i,1)) = 0.25 * (scalar)sin(2.0 * PI * (scalar)(i-1)/N);
        *(Re1+offs(N,1,i,1)) += 0.25 * (scalar)sin(4.0 * PI * (scalar)(i-1)/N);
        *(Re1+offs(N,1,i,1)) += 0.25 * (scalar)sin(8.0 * PI * (scalar)(i-1)/N);
        *(Re1+offs(N,1,i,1)) += 0.25 * (scalar)sin(16.0 * PI * (scalar)(i-1)/N);
    }
    matcpy(Re1, N, 1, Re2);
    matcpy(Im1, N, 1, Im2);
    
    if (!fft(N, Re2, Im2, 1, 1)) return EXIT_FAILURE;
    
    matcpy(Re2,N,1,Re3);
    matcpy(Im2,N,1,Im3);
    
    if (!fft(N, Re3, Im3, -1, 1)) return EXIT_FAILURE;
    
    printf("       original         fft           inverse\n");
    printf("        Real    Img     Real    Img     Real    Img\n");
    for (i=1; i<=N; i++) {
        printf("%4d %7.2f %7.2f %7.2f %7.2f %7.2f %7.2f\n",
	       i, 
	       *(Re1+offs(n,1,i,1)), *(Im1+offs(n,1,i,1)),
	       *(Re2+offs(n,1,i,1)), *(Im2+offs(n,1,i,1)),
	       *(Re3+offs(n,1,i,1)), *(Im3+offs(n,1,i,1)));
    }
    return EXIT_SUCCESS;
}
