#ifndef _RAND_GEN_H_
#define _RAND_GEN_H_

/* from www.math.keio.ac.jp */
void MTsgenrand(unsigned long);
double MTgenrand_f(void);
double MTgenrand_fh(void);
unsigned long MTgenrand_i(void);
/* initialize of random number sequence */
int init_random(unsigned long arg); 
unsigned int get_seed(void);

/* Two dimensional normal distribution */
void binormal_rand (double r, double *x, double *y) ;

/* Normal distribution, where mean is 0, and variance is 1.0 */
double normal_rand(void);

/* Gamma distribution */
double gamma_rand(double p);

/* Chi-square distribution */
double chisq_rand(double df);

/* $B;03QJ,I[(B */
double triangular_rand (void);

/* $B;X?tJ,I[(B */
double exp_rand (void);

/* $BN_>h(B($BQQ>h(B)$BJ,I[(B */
double power_rand(double n);

/* $B%3!<%7!<J,I[(B */
double cauchy_rand (void);

/* beta $BJ,I[(B */
double beta_rand1 (double a, double b);

/* F $BJ,I[(B */
double F_rand(double n1, double n2);

/* t $BJ,I[(B */
double t_rand (double df);

/* $B%m%8%9%F%#%C%/J,I[(B */
double logistic_rand(void);

/* $B4v2?J,I[(B */
int geometric_rand(double p) ;

/* $BFs9`J,I[(B */
int binomial_rand(int n, double p);

/* $B%]%o%=%sJ,I[(B */
int poisson_rand(double lambda);

/* $B%o%$%V%kJ,I[(B */
double weibull_rand(double alpha);

#endif _RAND_GEN_H_
