/*
 * @(#)matI - return unit matrix (Shinichi Asakawa)
 */
#include <stdlib.h>
#include "matrix_util.h"
#include "fileio_util.h"

matrix matI (int n)
{
    int i;
    matrix Ret;
    
    if ( n <= 0 ) {
        fprintf(stderr, "Invalid n(%d) in matI()\n", n);
        exit (EXIT_FAILURE);
    }

    if ((Ret = matinit(n,n)) == NULL) {
        fprintf(stderr, "Could not allocate memory in matI()\n");
        exit (EXIT_FAILURE);
    }

    for (i=1; i<=n; i++) {
        *(Ret+offs(n,n,i,i)) = 1.0;
    }
    return Ret;
}

#ifdef STANDALONE
#include <stdlib.h>
#include <time.h>


int usage(char *progname)
{
    fprintf(stderr,"%s - return a unit matrix of size n\n", progname);
    fprintf(stderr,"Usage:\n%s size\n", progname);
    exit (EXIT_FAILURE);
}

int main(int argc, char **argv)
{
    int size = 0;
    matrix Out;
    int argn=1;
    long loadingtime;

    if (argc == 1) usage(argv[0]);

    while (argn < argc && argv[argn][0] == '-' && argv[argn][1] != '\0') {
        if (keymatch(argv[argn], "--help")) { usage(argv[0]); } 
        else if (keymatch(argv[argn], "-h")) { usage(argv[0]); } 
        else { usage(argv[0]); }
        argn++;
    }
    if (sscanf(argv[argn], "%d", &size) != 1)  usage(argv[0]);
    if ( size <= 0 ) usage(argv[0]);

    Out = matI(size);

    fprintf(stdout, "### ProgramName: %s %d\n", argv[0], size);
    fprintf(stdout, "### Creator: Shinichi ASAKAWA <asakawa@twcu.ac.jp>\n");
    (void)time(&loadingtime);
    fprintf(stdout, "### CreationDate: %s", ctime(&loadingtime));
    return fwritemat(stdout, Out, size, size, "", "");
}
#endif STANDALONE
