/*
 * @(#)writemat.c 
 * by Shinichi ASAKAWA <asakawa@twcu.ac.jp>
 */
#include <stdlib.h>
#include <strings.h>
#include "general.h"
#include "matrix_util.h"
#include "fileio_util.h"

int vectwrite(FILE *fp, matrix  w, int siz, unsigned char *mes) 
{
    return fwritemat(fp, w, siz, 1, mes, "%.6g ");
}

int writemat(matrix w,           /* matrix to be written to FILE */
             int row,            /* size of row for matrix w     */
             int col,            /* size of column for matix w   */
             unsigned char *mes, /* header messages for output   */
             unsigned char *fmt  /* format to be written         */ ) 
{
    int i,j;
    unsigned char deffmt[32] = "%8.5f "; 
    
    if ( strlen(fmt) > 0) strcpy(deffmt,fmt);
    if (strlen(mes) > 1)  fprintf(stdout, "%s",mes);
    for (i=1; i<=row; i++){
        for (j=1; j<=col; j++){
            fprintf(stdout,deffmt,*(w+offs(row,col,i,j)));
            if (((j % 10) == 0) && (j != col) ) fprintf(stdout, "\n");
        }
        fprintf(stdout, "\n");
    }
    return OK;
}

int fwritemat(FILE *fp, matrix w,/* matrix to be written to FILE */
             int row,            /* size of row for matrix w     */
             int col,            /* size of column for matix w   */
             unsigned char *mes, /* header messages for output   */
             unsigned char *fmt  /* format to be written         */ ) 
{
    int i,j;
    unsigned char deffmt[32] = "%8.5f "; 

    if (strlen(fmt) > 0) strcpy(deffmt,fmt);
    if (strlen(mes) > 1)  fprintf(fp,"%s",mes);
    for (i=1; i<=row; i++){
        for (j=1; j<=col; j++)
            fprintf(fp,deffmt,*(w+offs(row,col,i,j)));
        fprintf(fp,"\n");
    }
    return OK;
}
