#include <math.h>
#include "general.h"
#include "rand_gen.h"

double beta_rand1 (double a, double b)  /* $B%Y!<%?J,I[(B 1 */
{
    double x, y;

    do {
	x = pow(MTgenrand_f(), 1 / a);  y = pow(MTgenrand_f(), 1 / b);
    } while (x + y > 1);
    return x / (x + y);
}

double beta_rand2 (double a, double b)  /* $B%Y!<%?J,I[(B 2 */
{
    double temp;
    
    temp = gamma_rand(a);
    return temp / (temp + gamma_rand(b));
}


double beta_rand(double a, double b) {
    return beta_rand1(a, b);
}

/**********************************************************/
#ifdef STANDALONE
#include <stdio.h>
#include <stdlib.h>
#include <time.h>

long loadingtime;
unsigned int SEED = 0;

void Usage (char *prg) {
    fprintf(stderr,"Usage:\n");
    fprintf(stderr,"%s A B N [SEED]\n", prg);
    fprintf(stderr,"arguments  A: parameter1 for beta distribution(double)\n");
    fprintf(stderr,"           B: parameter2 for beta distribution(double)\n");
    fprintf(stderr,"           N: number of data to be generated(int)\n");
    fprintf(stderr,"           SEED: seed of random number(long int)\n");
    exit (EXIT_FAILURE);
}

int main (int argc, char **argv) {
    int i, max = 0;
    double a=0.0, b=0.0;
    
    SEED = (unsigned)time(&loadingtime);
    
    switch (argc) {
    case 4:
        a = atof(argv[1]);
        b = atof(argv[2]);
        max = (unsigned)atoi(argv[3]);
        break;
    case 5:	
        a = atof(argv[1]);
        b = atof(argv[2]);
        max = (unsigned)atoi(argv[3]);
        SEED = atof(argv[4]); 
        break;
    default:
	Usage(argv[0]); exit (EXIT_FAILURE);
	/*
	  for (i=1; i<argc; i++){
	  if (argv[i][0] == '-'){
	  if (strcmp(argv[i],"-n") == 0) {
	  if (argv[++i] == NULL)  Usage(argv[0]);
	  max = (unsigned)atoi(argv[i]);
	  } else if (strcmp(argv[i],"-SEED") == 0) {
	  if (argv[++i] == NULL)  Usage(argv[0]);
	  SEED = atof(argv[i]); 
	  } else if (strcmp(argv[i],"-h") == 0) {
	  Usage(argv[0]);
	  exit (EXIT_FAILURE);
	  }
	  }
	  }
	*/
    }
    if (max == 0)     Usage(argv[0]);
    MTsgenrand(SEED);
    
    fprintf(stdout, "### ProgramName: %s %g %g %d %d\n", argv[0], a, b, max, SEED);
    fprintf(stdout, "### Creator: Shinichi ASAKAWA <asakawa@twcu.ac.jp>\n");
    (void)time(&loadingtime);
    fprintf(stdout, "### CreationDate: %s", ctime(&loadingtime));
    
    for (i = 0; i < max; i++) {
	printf("%10.5f\n", beta_rand(a,b));
    }
    return EXIT_SUCCESS;
}
#endif STANDALONE
