/* $B%+%$(B2$B>hJ,I[(B */
#include <math.h>
#include "general.h"
#include "rand_gen.h"

double chisq_rand1 (int n)  {
    int i;
    double s, t;

    s = 0.0;
    for (i = 0; i < n; i++) {  
	t = normal_rand();  
	s += t * t;  
    }
    return s;
}

double chisq_rand2(double n)  /* $B%+%$(B2$B>hJ,I[(B */
{
	return 2.0 * gamma_rand(0.5 * n);
}

double chisq_rand(double  n) {
    return chisq_rand2 (n);
}

/**********************************************************/
#ifdef STANDALONE
#include <stdio.h>
#include <stdlib.h>
#include <time.h>

long loadingtime;
unsigned int SEED = 0;

void Usage (char *prg) {
  fprintf(stderr,"Usage:\n");
  fprintf(stderr,"%s DF N [SEED]\n", prg);
  fprintf(stderr,"arguments  DF: degree of freedom for chi square distribution(int)\n");
  fprintf(stderr,"           N: number of data to be generated(int)\n");
  fprintf(stderr,"           SEED: seed of random number(long int)\n");
  exit (EXIT_FAILURE);
}

int main (int argc, char **argv) {
    int i, max = 0;
    double df=0.0;

    SEED = (unsigned)time(&loadingtime);

    switch (argc) {
    case 3:
        df = atof(argv[1]);
        max = (unsigned)atoi(argv[2]);
        break;
    case 4:	
        df = atof(argv[1]);
        max = (unsigned)atoi(argv[2]);
        SEED = atof(argv[3]); 
        break;
    default:
	Usage(argv[0]); exit (EXIT_FAILURE);
    }
    if (max == 0)     Usage(argv[0]);
    if (df == 0.0)     Usage(argv[0]);
    MTsgenrand(SEED);

    fprintf(stdout, "### ProgramName: %s %g %d %d\n", argv[0], df, max, SEED);
    fprintf(stdout, "### Creator: Shinichi ASAKAWA <asakawa@twcu.ac.jp>\n");
    (void)time(&loadingtime);
    fprintf(stdout, "### CreationDate: %s", ctime(&loadingtime));

    for (i = 0; i < max; i++) {
	printf("%10.5f\n", chisq_rand(df));
    }
    return EXIT_SUCCESS;
}
#endif STANDALONE
