/* $B4v2?J,I[(B 1 */
#include <math.h>
#include "general.h"
#include "rand_gen.h"

int geometric_rand1 (double p)  
{
    int n;

    n = 1;
    while (MTgenrand_f() > p) n++;
    return n;
}

int geometric_rand2(double p)  /* $B4v2?J,I[(B 2 */
{
    return ceil(log(1 - MTgenrand_f()) / log(1 - p));
}


int geometric_rand(double p) {
    return geometric_rand2(p);
}

/**********************************************************/
#ifdef STANDALONE
#include <stdio.h>
#include <stdlib.h>
#include <time.h>

long loadingtime;
unsigned int SEED = 0;

void Usage (char *prg) {
    fprintf(stderr,"Usage:\n");
    fprintf(stderr,"%s P N [SEED]\n", prg);
    fprintf(stderr,"options  P: parameter for geometric distribution\n");
    fprintf(stderr,"         N: number of data to be generated(int)\n");
    fprintf(stderr,"         SEED: seed of random number(long int)\n");
    exit (EXIT_FAILURE);
}

int main (int argc, char **argv) {
    int i, max = 0;
    double p = 0.0;

    SEED = (unsigned)time(&loadingtime);

    switch (argc) {
    case 3:
        p = atof(argv[1]);
        max = (unsigned)atoi(argv[2]);
        break;
    case 4:	
        p = atof(argv[1]);
        max = (unsigned)atoi(argv[2]);
        SEED = atof(argv[3]); 
        break;
    default:
	Usage(argv[0]); exit (EXIT_FAILURE);
    }
    if (max == 0)     Usage(argv[0]);
    if (p == 0.0)     Usage(argv[0]);
    MTsgenrand(SEED);

    fprintf(stdout, "### ProgramName: %s %g %d %d\n", argv[0], p, max, SEED);
    fprintf(stdout, "### Creator: Shinichi ASAKAWA <asakawa@twcu.ac.jp>\n");
    (void)time(&loadingtime);
    fprintf(stdout, "### CreationDate: %s", ctime(&loadingtime));

    for (i = 0; i < max; i++) {
	printf("%7d\n", geometric_rand(p));
    }
    return EXIT_SUCCESS;
}
#endif STANDALONE
