#include <math.h>
#include "general.h"
#include "rand_gen.h"

double normal_rand1 (void)
{
    return MTgenrand_f() + MTgenrand_f() + MTgenrand_f() + MTgenrand_f() 
         + MTgenrand_f() + MTgenrand_f() + MTgenrand_f() + MTgenrand_f() 
         + MTgenrand_f() + MTgenrand_f() + MTgenrand_f() + MTgenrand_f() - 6.0;
}


double normal_rand2 (void)  /* ʬ 2 */
{
    static int sw = 0;
    static double t, u;

    if (sw == 0) {
	sw = 1;
	t = sqrt(-2.0 * log(1 - MTgenrand_f()));  
	u = 2.0 * PI * MTgenrand_f();
	return t * cos(u);
    } else {
	sw = 0;
	return t * sin(u);
    }
}

double normal_rand3 (void)  /* ʬ 3 */
{
    static int sw = 0;
    static double r1, r2, s;

    if (sw == 0) {
        sw = 1;
        do {
	    r1 = 2.0 * MTgenrand_f() - 1.0;
	    r2 = 2.0 * MTgenrand_f() - 1.0;
	    s = r1 * r1 + r2 * r2;
	} while ( s > 1.0 || s == 0.0);
        s = sqrt(-2 * log(s) / s);
        return r1 * s;
    } else {
        sw = 0;
        return r2 * s;
    }
}

double normal_rand(void) {
    return normal_rand3();
}

/**********************************************************/
#ifdef STANDALONE
#include <stdio.h>
#include <stdlib.h>
#include <time.h>

long loadingtime;
unsigned int SEED;

void Usage (char *prg) {
    fprintf(stderr,"Usage:\n");
    fprintf(stderr,"\n%s N [SEED]\n", prg);
    fprintf(stderr,"arguments    N: number of data to be generated(int)\n");
    fprintf(stderr,"          SEED: seed of random number(long int)\n");
    exit (EXIT_FAILURE);
}

int main (int argc, char **argv) {
    int i, max = 0;

    SEED = (unsigned)time(&loadingtime);

    switch (argc) {
    case 2:
        max = (unsigned)atoi(argv[1]);
        break;
    case 3:
        max = (unsigned)atoi(argv[1]);
        SEED = atof(argv[2]); 
        break;
    default:
	/*
    	for (i=1; i<argc; i++){
            if (argv[i][0] == '-'){
                if (strcmp(argv[i],"-n") == 0) {
                    if (argv[++i] == NULL)  Usage(argv[0]);
                    max = (unsigned)atoi(argv[i]);
                } else if (strcmp(argv[i],"-SEED") == 0) {
                    if (argv[++i] == NULL)  Usage(argv[0]);
                    SEED = atof(argv[i]); 
                } else if (strcmp(argv[i],"-h") == 0) {
                    Usage(argv[0]);
                    exit (EXIT_FAILURE);
                }
            }
        }
	*/
    }
    if (max == 0)     Usage(argv[0]);
    MTsgenrand(SEED);

    fprintf(stdout, "### ProgramName: %s %d %d\n", argv[0], max, SEED);
    fprintf(stdout, "### Creator: Shinichi ASAKAWA <asakawa@twcu.ac.jp>\n");
    (void)time(&loadingtime);
    fprintf(stdout, "### CreationDate: %s", ctime(&loadingtime));

    for (i = 0; i < max; i++) {
	printf("%10.5f\n", normal_rand());
    }
    return EXIT_SUCCESS;
}
#endif STANDALONE
