#include <math.h>
#include "general.h"
#include "rand_gen.h"

double power_rand1 (int n)  
{
    int i;
    double ret, r;

    ret = MTgenrand_f();
    for (i = 0; i < n; i++) {
	if ((r = MTgenrand_f()) > ret) {
	    ret = r;
	}
    }
    return ret;
}

double power_rand2(double n)  /* ߾ʬ 2 */
{
    return pow(MTgenrand_f(), 1.0 / (n + 1));
}

double power_rand(double n) 
{
    return power_rand2(n);
}

/**********************************************************/
#ifdef STANDALONE
#include <stdio.h>
#include <stdlib.h>
#include <time.h>

long loadingtime;
unsigned int SEED;

void Usage (char *prg) {
  fprintf(stderr,"Usage:\n");
  fprintf(stderr,"%s POWER N [SEED]\n", prg);
  fprintf(stderr,"arguments POWER: parameter for power distribution(double)\n");
  fprintf(stderr,"          N: number of data to be generated(int)\n");
  fprintf(stderr,"          SEED: seed of random number(long int)\n");
  exit (EXIT_FAILURE);
}

int main (int argc, char **argv) {
    int i, max = 0;
    double power = 0.0;

    SEED = (unsigned)time(&loadingtime);
    switch (argc) {
    case 3:
        power = atof(argv[1]);
        max = (unsigned)atoi(argv[2]);
        break;
    case 4:
        power = atof(argv[1]);
        max = (unsigned)atoi(argv[2]);
        max = (unsigned)atoi(argv[3]);
        SEED = atof(argv[2]); 
        break;
    default:
	Usage(argv[0]); exit (EXIT_FAILURE);
	/*
    	for (i=1; i<argc; i++){
            if (argv[i][0] == '-'){
                if (strcmp(argv[i],"-n") == 0) {
                    if (argv[++i] == NULL)  Usage(argv[0]);
                    max = (unsigned)atoi(argv[i]);
                } else if (strcmp(argv[i],"-SEED") == 0) {
                    if (argv[++i] == NULL)  Usage(argv[0]);
                    SEED = atof(argv[i]); 
                } else if (strcmp(argv[i],"-h") == 0) {
                    Usage(argv[0]);
                    exit (EXIT_FAILURE);
                }
            }
        }
	*/
    }
    if (max == 0)     Usage(argv[0]);
    MTsgenrand(SEED);

    fprintf(stdout," ### ProgramName: %s %g %d %d\n", argv[0], power, max, SEED);
    fprintf(stdout, "### Creator: Shinichi ASAKAWA <asakawa@twcu.ac.jp>\n");
    (void)time(&loadingtime);
    fprintf(stdout, "### CreationDate: %s", ctime(&loadingtime));

    for (i = 0; i < max; i++) {
	printf("%10.5f\n", power_rand(power));
    }
    return EXIT_SUCCESS;
}
#endif STANDALONE
