/*	Calculate the probability according with F-distribution.
 *	usage: p_f df1 df2 f
 *
 *		Written by S.Asakawa 1993/05/04
 */
#include <math.h>
#include "general.h"

double p_f(int df1, int df2, double f)
/* ͳ(df1,df2)Σʬۤ˽ΨѿϰϤȤΨ */
{
	int i;
	double cos2, sin2, p, temp, ret;
	int flag;

	cos2 = 1.0 / ( 1.0 + (double)df1 * f / (double)df2);
	sin2 = 1.0 - cos2;
	if( ((df1 % 2) == 1) && ((df2 % 2) == 1)){
		p = atan(sqrt((double)df2 / ((double)df1 * f)));
		temp = sqrt(sin2 * cos2);
		i = 3;
		while( i <= df1 ){
			p += temp;
			temp *= (double)( i - 1 ) * sin2 / (double)i;
			i += 2;
		}
		temp *= (double)df1; 
		i = 3;
		while( i <= df2 ){
			p -= temp;
			temp *= (double)( df1 + i - 2 ) * cos2 / (double)i;
			i += 2;
		}
		ret = 1.0 - p * 2.0 / Pi;
	} 
	else {
		if( (df1 % 2) == 1){
			temp = cos2; 
			cos2 = sin2; 
			sin2 = temp;
			i = df1; 
			df1 = df2; 
			df2 = i; 
			flag = 1;
		} 
		else {
			flag = 0;
		}
		p = exp((double)df2 / 2.0 * log(cos2));
		temp = p; 
		i = 2;
		while(i < df1){
			temp *= (double)( df2 + i - 2 ) * sin2 / (double)i;
			p += temp; 
			i += 2;
		}
		ret = (flag == 1) ? p : 1 - p;
	}
	return ret;
}

#ifdef TEST
#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>

void usage(void)
{
	fprintf(stderr,"p_f: Calculate the probability according with F-distribution\n");
	fprintf(stderr,"usage:p_f df1 df2 f\n");
	exit(FALSE);
}

int main( int argc, char **argv )
{
	double f;
	int df1, df2;

	if( argc != 4 )	usage();
	df1 = atoi(argv[1]);
	df2 = atoi(argv[2]);
	f   = atof(argv[3]);

	fprintf(stdout,"%g\n", p_f(df1,df2,f));
	return TRUE;
}
#endif
