/* Calculate the probability according with Normal-distribution.
   Written by S.Asakawa 1993/05/04 */
#include <math.h>
#include "general.h"
/*
#define Eps 1.0e-20
*/

/* N(0,1) ˽Ψѿ0 < z < x ϰϤȤΨ */
/* ưʤ */
double p_norm( double x )
{
    int i;
    double z,lastp, p, temp;

    z = x * x;
    p = sqrt( z / ( 2.0 * Pi * exp(x)));
    temp = p;
    if ( fabs(temp) < eps ) {
	return 0.0;
    }
    i = 3;
    do {
	lastp = p;
	temp *= x / (double)i;
	p += temp;
	i += 2;
    } while (fabs(p - lastp) > eps);
    return p;
}

#ifdef TEST
#include    <stdio.h>
#include    <stdlib.h>
#include    <string.h>

void usage(char *prgname)
{
    fprintf(stderr,"%s - Calculate the probability according with Normal distribution\n", prgname);
    fprintf(stderr,"usage: %s z\n", prgname);
    exit (EXIT_FAILURE);
}

int main( int argc, char **argv )
{
    double z;

    if( argc != 2 )    usage(argv[0]);
    if (sscanf(argv[1],"%lg", &z)== 0) {
	fprintf(stderr, "Invalid z_score(%s)\n",argv[1]);
	exit (EXIT_FAILURE);
    }
    
    fprintf(stdout,"%g\n", p_norm(z));
    return EXIT_SUCCESS;
}
#endif
