/* Calculate the probability according with t-distribution.
   Written by S.Asakawa 1993/05/04 */
#include <math.h>
#include "general.h"

/* ͳ٣Σʬۤ˽ΨѿϰϤȤΨ */
double p_t(int df, double t)
{
    int i;
    double cos2, p = 0.0, temp, ret;

    cos2 = 1.0 / ( 1.0 + (t * t)/df );
    i = ( df % 2 ) + 2;
    temp = sqrt(1.0 - cos2);
    while (i <= df) {
        p += temp;
        temp *= ((double)i - 1.0 ) * cos2 / (double)i;
        i += 2;
    }
    if ( (df % 2) == 1 ) {
        ret = (p * sqrt(cos2) + atan(t / sqrt((double)df)))/Pi;
    } else {
        ret = p / 2.0;
    }
    return ret;
}

#ifdef TEST
#include    <stdio.h>
#include    <stdlib.h>
#include    <string.h>

void usage(char *prgname)
{
    fprintf(stderr,"%s - Calculate the probability according with t distribution\n", prgname);
    fprintf(stderr,"usage:%s <df:int> <t:double>\n", prgname);
    exit (EXIT_FAILURE);
}

int main( int argc, char **argv )
{
    int df;
    double t;

    if( argc != 3 ) usage(argv[0]);
    if (sscanf(argv[1], "%d", &df) == 0) {
	fprintf(stderr, "sscanf() error at main in p_t()\n");
	usage(argv[0]);
    }
    if (sscanf(argv[2], "%lg", &t) == 0) {
	fprintf(stderr, "sscanf() error at main in p_t()\n");
	usage(argv[0]);
    }

    fprintf(stdout,"%g\n", 0.5 - p_t(df, t));
    return EXIT_SUCCESS;
}
#endif
