/*	Calculate the Muller-Urban weight from normalized z score
 *		Written by S.Asakawa 1993/05/04
 */
#include <math.h>
#include "general.h"

extern double z2p(double);

double z2MUw(double z)
/* MeullerUbanٽţ */
{
  double  y, p, ret;
  y = exp( -0.5 * z * z ) / sqrt( 2.0 * Pi);
  p = z2p(z);
  ret = y * y / ( p * ( 1.0 - p ));
  return ret;
}

#ifdef TEST
#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>

void usage(void)
{
  fprintf(stderr,"z2muw: Calculate the Muller-Urban weight from normalized z score\n");
  fprintf(stderr,"usage: z2muw z \n");
  exit (EXIT_FAILURE);
}

int main( int argc, char **argv )
{
  double z;

  if( argc != 2 )	usage();
  z = atof(argv[1]);

  fprintf(stdout,"%4.5f ", z2MUw(z));
  return TRUE;
}
#endif
