/*	Calculate the probability according with normal distribution from the z score
 		Written by S.Asakawa 1993/05/04 */
#include <math.h>
#include "general.h"

double z2p(double y)
/* Hastings(1955)ζȤä z Ψ p   */
/* Żҷ׻Τζ׻޽ѡ1973          */
/* ưʳؤΤBASIC硤ɵסǲ1983, p.59     */
/* p ٤Ͼʲ 3                                    */
{
  double  x1=0.196854, x2=0.115195, x3=0.000344, x4=0.019527;
  double a,b,c,d,z;

  z = fabs(y);
  a = (x4 * z + x3) * z + x2;
  b = a * z + x1;
  c = b * z + 1;
  d = 0.5 * pow(c, -4.0);
  return ( (y >= 0) ? (1 - d) : d );
}

#ifdef TEST
#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>

void usage(char *prgname)
{
  fprintf(stderr,"%s - Calculate the probability according with normal distribution from the z score\n", prgname);
  fprintf(stderr,"Usage: %s z_score\n", prgname);
  exit (EXIT_FAILURE);
}

int main(int argc, char **argv)
{
	double z;

	if( argc != 2 )	usage(argv[0]);
  sscanf(argv[1],"%lg",&z);

	fprintf(stdout,"%g\n", z2p(z));
	return EXIT_SUCCESS;
}
#endif
